function Nr = BootstrapC(N,M,type)
%
%INPUT
%
% N      THE EMPIRICAL RAW DATA SET /INDICATOR MATRIX 
%
% M      VECTOR WITH THE NUMBER OF CATEGORIES IN EACH SUBSET
%
% type   1 returns the Burt matrix (NEEDS AN INDICATOR MATRIX AS INPUT; ONLY FOR MCA)
%        2 returns a contingence table (ONLY FOR CA)
%
% OUTPUT
%
% Nr     RANDOM BURT MATRIX IF TYPE = 1
%        RANDOM CONTINGENCE MATRIX IF TYPE = 2
%

if type == 2,
I=M(1,1);    
J=M(1,2);
    %vectors of ones
    Ir = ones(I,1);
    Ic = ones(J,1);

%grand total
    X=N;
    [n,tmp]=size(X); 

    again = 1;
    while (again == 1),
        again = 0;
        
        %Boostrap sampling
        Xb = [X(round(rand(n,1)*(n-1))+1,1) X(round(rand(n,1)*(n-1))+1,2)] ;
    
        Cb =zeros(I,J);
        %Compute random C
        for k=1:n,
            Cb(Xb(k,1),Xb(k,2)) = Cb(Xb(k,1),Xb(k,2)) + 1;
        end;
    
        if (min(sum(Cb)') == 0),
            again = 1;
            disp('Again 0');
        end;
        if (min(sum(Cb')') == 0),
            again = 1;
            disp('Again 1');
        end;
        
    end;
    
    Nr=Cb;

end;

if type == 1,
    
    Z=N;

    [tmp,k]=size(M);
    [n,tmp]=size(Z);

    again = 1;
    while (again == 1),
        again = 0;

        Zb=[];
        for i=1:k,
           j2 =sum(M(1:i)');
           j1 = j2-M(i)+1;
           Zi = Z(:,[j1:j2]);
           ind=round(rand(n,1)*(n-1))+1;
           Zr = Zi( ind, : );
           Zb=[Zb Zr];
        end;
        if (min(sum(Zb)') == 0),
            again = 1;
            disp('Again 2');
        end;
        if (min(sum(Zb')') == 0),
            again = 1;
            disp('Again 3');
        end;
        
    end;
    
    Nr=Zb'*Zb;
end;

return