function Nr = RBurt(N,M,type)
%
%INPUT
%
% N      THE EMPIRICAL BURT MATRIX 
%        OR THE NUMBER OF INDIVIDUALS
%
% M      VECTOR WITH THE NUMBER OF CATEGORIES IN EACH SUBSET
%
% type   1 returns the Burt matrix 
%        2 returns a contingence table (ONLY FOR CA)
%
% OUTPUT
%
% Nr     RANDOM BURT MATRIX IF TYPE = 1
%        RANDOM CONTINGENCE MATRIX IF TYPE = 2
%

[tmp1,tmp2]=size(M);
Q=max([tmp1; tmp2]);
clear tmp1 tmp2;

[tmp1,tmp2]=size(N);
if tmp1 > 1,
   n=trace(N(1:M(1,1),1:M(1,1)));
else
    n=N;
end;

again=1;
while (again == 1),
     again = 0;

    Z=[];
    for j=1:Q,
        z =zeros(n,(M(1,j)));
        indr=round(rand(n,1)*(M(1,j)-1)+1);
        for i=1:n
            z (i,indr(i))= 1;
        end;    
        Z=[Z z];
    end;
        
    if (min(sum(Z)') == 0),
        again = 1;
        disp('Again');
    end;
    
end;

if type ==2,
    B = Z'*Z;
    Nr = B(1:M(1,1),(M(1,1)+1):(M(1,1)+M(1,2)));
else
    Nr = Z'*Z;
end;

return