
function varargout = MultipleCar(varargin)
% MCAR MATLAB code for mcar.fig
% addpath lib;  NOT IN THE COMPILED VERSION
addpath lib;  

w = warning ('off','all');

if nargin == 0  % LAUNCH GUI

	fig = openfig('mcar','reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
    guidata(fig, handles);

    %Data Analaysis initialitation
    data.I=0;
    data.J=0;
    data.N=[];
    data.labels.x={};
    data.labels.y={};
    data.raw.x=[];
    data.raw.y=[];
    data.model.k=0;
    data.model.coordinates=0;
    data.rotation.compute=0;
    data.rotation.weights=0;
    data.rotation.method=0;
    data.supplementary='NO';

    data.MCA.k=0;
    data.MCA.n_var=0;
    data.MCA.model=0;
    data.MCA.X=[];
    data.MCA.Z=[];
    data.MCA.M=[];
    data.MCA.B=[];
    data.MCA.supvariables=[];
    data.MCA.labels={};
    data.MCA.supplementary='NO';
    
    indices.rows=0;
    indices.columns=0;
    indices.max=0;
    
    output.NO=[];
    
    setappdata(0,'data',data);
    setappdata(0,'output',output);
    setappdata(0,'indices',indices);

    %INITIALITATIONS
    ActualizeListVariables(handles);  
%    set(handles.VarData,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
    set(handles.VarData,'string','');
    set(handles.VarCategories,'string','');
    set(handles.VarLabels,'string','');
    set(handles.ButtonData,'string','>');        
    set(handles.CategoriesButton,'string','>');        
    set(handles.LabelsButton,'string','>');        
    set(handles.VarCategories,'string','');
    set(handles.CategoriesButton,'string','>');
    set(handles.SupplementaryPoints,'string','');
    set(handles.DataType,'value',1);
    set(handles.NumberOfDimensions,'string','0');
    set(handles.Model4,'value',1);
    set(handles.Model3,'value',0);
    set(handles.ComputeRotation,'value',1);
    set(handles.WeightsRotation,'enable','on');
    set(handles.WeightsRotation,'value',1);
    set(handles.RotationMethod,'enable','on');
    set(handles.RotationMethod,'value',1);
    set(handles.DetailedOutput,'value',0);
    set(handles.ShowMap,'value',1);
    set(handles.AssessDimesionality,'value',1);
    set(handles.ParallelAnalysis,'value',0);
    set(handles.ShowVariablesMap,'value',1);
    set(handles.ShowIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);
    set(handles.ShowMap,'enable','on');
    set(handles.MapVariables,'value',1);
    set(handles.MapVariablesObservations,'value',0);
    set(handles.MapVariables,'enable','on');
    set(handles.MapVariablesObservations,'enable','on');
    
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

end
return



% --- Executes just before mcar is made visible.
function mcar_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mcar (see VARARGIN)

% Choose default command line output for mcar
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mcar wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mcar_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in DataType.
function DataType_Callback(hObject, eventdata, handles)
% hObject    handle to DataType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns DataType contents as cell array
%        contents{get(hObject,'Value')} returns selected item from DataType

    tmp=get(handles.DataType,'Value');
    %CHECKS IF IT IS A BURT MATRIX
    if (tmp == 3),
       set(handles.ShowVariablesMap,'enable','on');
       set(handles.ShowIndividualsMap,'enable','off');
       set(handles.ShowVariablesIndividualsMap_EqualSpread,'enable','off');
       set(handles.ShowVariablesIndividualsMap,'enable','off');
       set(handles.ShowVariablesMap,'value',1);
       set(handles.ShowVariablesIndividualsMap,'value',0);
       set(handles.ShowIndividualsMap,'value',0);
       set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);
       
    else,
       set(handles.ShowVariablesMap,'enable','on');
       set(handles.ShowIndividualsMap,'enable','on');
       set(handles.ShowVariablesIndividualsMap,'enable','on');
       set(handles.ShowVariablesIndividualsMap_EqualSpread,'enable','on');
    end;

    %THE VARIABLE IS CLEANED
    tmp=get(handles.VarData,'string');
    if isempty(tmp),
        %NO NOTHING
    else,
        set(handles.VarData,'string','');
        set(handles.ButtonData,'string','>');        
        set(handles.SupplementaryPoints,'string','');
        set(gcbf,'Pointer','arrow');
        return;
    end;
return;

% --- Executes during object creation, after setting all properties.
function DataType_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DataType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in VariablesList.
function VariablesList_Callback(hObject, eventdata, handles)
% hObject    handle to VariablesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns VariablesList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from VariablesList


% --- Executes during object creation, after setting all properties.
function VariablesList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to VariablesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function VarData_Callback(hObject, eventdata, handles)
% hObject    handle to VarData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of VarData as text
%        str2double(get(hObject,'String')) returns contents of VarData as a double


% --- Executes during object creation, after setting all properties.
function VarData_CreateFcn(hObject, eventdata, handles)
% hObject    handle to VarData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ButtonData.
function ButtonData_Callback(hObject, eventdata, handles)
% hObject    handle to ButtonData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    set(gcbf,'Pointer','watch');

    %THE VARIABLE IS CLEANED
    tmp=get(handles.VarData,'string');
    if isempty(tmp),
        %NO NOTHING
    else,
        set(handles.VarData,'string','');
        set(handles.ButtonData,'string','>');        
        set(handles.SupplementaryPoints,'string','');
        set(gcbf,'Pointer','arrow');
        set(handles.DataType,'enable','on');

        return;
    end;

    s    = get(handles.VariablesList,'value');
    str  = get(handles.VariablesList,'string');

     %CHECKS IF THE MATRIX EXISTS IN THE WORK MEMORY SPACE
    str1 = 'exist(''';
    str2=ClearFields(str(s));
    str3 = ''',''var'')';
    str4 = char(strcat(str1,str2,str3));
    
    f = evalin('base',str4);
    if f == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable is not anymore available in the work memory space','MultipleCar','error');
        ActualizeListVariables(handles);
        return;
    end;
    
    %CHECKS IF IT IS NUMERICAL
    str1 = 'isnumeric(';
    str2 = str(s);
    str3 = ')';
    str4 = char(strcat(str1,str2,str3));

    f= evalin('base',str4); 
    if f == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable is not a numerical one','MultipleCar','error');
        return;
    end;
    
    %CHECKS IF IT IS A MATRIX
    str1 = {'global '};
    str2=ClearFields(str(s));
    str3 = {';'};
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    str1 = '[f1, f2]=size(';
    str2 = str(s);
    str3 = ');';
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    if f2 < 2 ,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable must be a matrix','MultipleCar','error');
        return;
    end;
    if f1 < 2 ,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable must be a matrix','MultipleCar','error');
        return;
    end;
    
    tmp=get(handles.DataType,'Value');
    %CHECKS IF IT DOES NOT LOOK LIKE AS RAW DATA
    if (tmp == 1),
        str1 = 'f=abs(max(sum(';
        str2 = str(s);
        str3 = ''')'') - min(sum(';
        str4 = ''')''));';
        str5 = char(strcat(str1,str2,str3,str2,str4));
        eval(str5);
        if f == 0,
            set(gcbf,'Pointer','arrow');
            warndlg('This matrix seems an indicator matrix instead of raw data!','MultipleCar');
            set(gcbf,'Pointer','watch');
        elseif f1 == f2,
            set(gcbf,'Pointer','arrow');
            warndlg('This matrix seems a Burt matrix instead of raw data!','MultipleCar');
            set(gcbf,'Pointer','watch');
        else,
            %computes maximum values
            str1 = {'global '};
            str2=ClearFields(str(s));
            str3 = {';'};
            str4 = char(strcat(str1,str2,str3));
            eval(str4); 
            str1 = 'MCAR_maxima_in_rawdata=max(';
            str2 = str(s);
            str3 = ');';
            str4 = char(strcat(str1,str2,str3));
            evalin('base',str4);
            ActualizeListVariables(handles);       
        end;
        
    end;
   
    %CHECKS IF IT IS AN INDICATOR MATRIX
    if (tmp == 2),
        str1 = 'f=abs(max(sum(';
        str2 = str(s);
        str3 = ''')'') - min(sum(';
        str4 = ''')''));';
        str5 = char(strcat(str1,str2,str3,str2,str4));
        eval(str5);
        if f > 0,
            set(gcbf,'Pointer','arrow');
            msgbox('This matrix does not look like as an indicator matrix!                 Remember that missing values are not allowed in the indicator matrix','MultipleCar','error');
            return;
        end;
    end;
    %CHECKS IF IT IS A BURT MATRIX
    if (tmp == 3),
        if f1 ~= f2,
            set(gcbf,'Pointer','arrow');
            msgbox('This matrix does not look like as a Burt matrix!                              It must be a square matrix (i.e., the same number of columns as rows)','MultipleCar','error');
            return;
        end;
    end;
    
    %THE VARIABLE IS ASSIGNED
    set(handles.VarData,'string',str(s));
    set(handles.ButtonData,'string','<');
    set(handles.DataType,'enable','off');
    
    set(gcbf,'Pointer','arrow');

return;

% --- Executes on button press in CategoriesButton.
function CategoriesButton_Callback(hObject, eventdata, handles)
% hObject    handle to CategoriesButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    set(gcbf,'Pointer','watch');

    %THE VARIABLE IS CLEANED
    tmp=get(handles.VarCategories,'string');
    if isempty(tmp),
        %NO NOTHING
    else,
        set(handles.VarCategories,'string','');
        set(handles.CategoriesButton,'string','>');        
        set(gcbf,'Pointer','arrow');
        return;
    end;

     s    = get(handles.VariablesList,'value');
     str  = get(handles.VariablesList,'string');

     %CHECKS IF THE MATRIX EXISTS IN THE WORK MEMORY SPACE
    str1 = 'exist(''';
    str2=ClearFields(str(s));
    str3 = ''',''var'')';
    str4 = char(strcat(str1,str2,str3));
    
    f = evalin('base',str4);
    if f == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable is not anymore available in the work memory space','MultipleCar','error');
        ActualizeListVariables(handles);
        return;
    end;
    
    %CHECKS IF IT IS NUMERICAL
    str1 = 'isnumeric(';
    str2 = str(s);
    str3 = ')';
    str4 = char(strcat(str1,str2,str3));

    f= evalin('base',str4); 
    if f == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable is not a numerical one','MultipleCar','error');
        return;
    end;
    
    %CHECKS IF IT IS A MATRIX
    str1 = {'global '};
    str2=ClearFields(str(s));
    str3 = {';'};
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    str1 = '[f1, f2]=size(';
    str2 = str(s);
    str3 = ');';
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    if f1 * f2 == 1 ,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable must be a matrix','MultipleCar','error');
        return;
    end;
    
    if f1 * f2 > max([f1;f2]),
        set(gcbf,'Pointer','arrow');
        msgbox('The variable must be a matrix','MultipleCar','error');
        return;
    end;
    
    %THE VARIABLE IS ASSIGNED
    set(handles.VarCategories,'string',str(s));
    set(handles.CategoriesButton,'string','<');
    set(gcbf,'Pointer','arrow');
return; 

function VarCategories_Callback(hObject, eventdata, handles)
% hObject    handle to VarCategories (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of VarCategories as text
%        str2double(get(hObject,'String')) returns contents of VarCategories as a double


% --- Executes during object creation, after setting all properties.
function VarCategories_CreateFcn(hObject, eventdata, handles)
% hObject    handle to VarCategories (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in LabelsButton.
function LabelsButton_Callback(hObject, eventdata, handles)
% hObject    handle to LabelsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    set(gcbf,'Pointer','watch');
    
    %THE VARIABLE IS CLEANED
    tmp=get(handles.VarLabels,'string');
    if isempty(tmp),
        %NO NOTHING
    else,
        set(handles.VarLabels,'string','');
        set(handles.LabelsButton,'string','>');        
        set(gcbf,'Pointer','arrow');
        return;
    end;

     s    = get(handles.VariablesList,'value');
     str  = get(handles.VariablesList,'string');
    %CHECKS IF THE MATRIX EXISTS IN THE WORK MEMORY SPACE
    str1 = 'exist(''';
    str2=ClearFields(str(s));
    str3 = ''',''var'')';
    str4 = char(strcat(str1,str2,str3));
    
    f = evalin('base',str4);
    if f == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable is not anymore available in the work memory space','MultipleCar','error');
        ActualizeListVariables(handles);
        return;
    end;
    
    %CHECKS IF IT IS STRING
    str1 = 'ischar(';
    str2 = str(s);
    str3 = ')';
    str4 = char(strcat(str1,str2,str3));

    f1= evalin('base',str4); 
    str1 = 'iscell(';
    str4 = char(strcat(str1,str2,str3));
    f2 = evalin('base',str4);
    if (f1+f2) == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable has to contain text','MultipleCar','error');
        return;
    end;
    
    %THE VARIABLE IS ASSIGNED
    set(handles.VarLabels,'string',str(s));
    set(handles.LabelsButton,'string','<');
    set(gcbf,'Pointer','arrow');
    
return;


function VarLabels_Callback(hObject, eventdata, handles)
% hObject    handle to VarLabels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of VarLabels as text
%        str2double(get(hObject,'String')) returns contents of VarLabels as a double


% --- Executes during object creation, after setting all properties.
function VarLabels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to VarLabels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function output=ActualizeListVariables(handles)
% if output == 1   There is data available
% if output == 0   There is not data

    set(gcbf,'Pointer','watch');
    output = 0;
    evalin('base','clear ans me');
    vars = evalin('base','who');
    [v,tmp2]=size(vars);
    if v>0,
        %ENTER VARIABLES IN THE VARLIST

        %numerical variables
        str={};
        for i=1:v,
            str1 = 'isnumeric(';
            str2 = vars(i);
            str3 = ')';
            str4 = char(strcat(str1,str2,str3));
            f= evalin('base',str4); 
            if f == 1,
               str=[str; vars(i)];
            end;
        end;
        %char variables
        for i=1:v,
            str1 = 'ischar(';
            str2 = vars(i);
            str3 = ')';
            str4 = char(strcat(str1,str2,str3));
            f= evalin('base',str4); 
            if f == 1,
               str=[str; vars(i)];
            end;
        end;
        %cell variables
        for i=1:v,
            str1 = 'iscell(';
            str2 = vars(i);
            str3 = ')';
            str4 = char(strcat(str1,str2,str3));
            f= evalin('base',str4); 
            if f == 1,
               str=[str; vars(i)];
            end;
        end;
        %structures
        for i=1:v,
            str1 = 'isstruct(';
            str2 = vars(i);
            str3 = ')';
            str4 = char(strcat(str1,str2,str3));
            f= evalin('base',str4); 
            if f == 1,
                str1 = 'fieldnames(';
                str2 = vars(i);
                str3 = ')';
                str4 = char(strcat(str1,str2,str3));
                varsFields= evalin('base',str4); 
                [vf,tmp2]=size(varsFields);
                for j=1:vf,
                    str1 = 'isnumeric(';
                    str2=strcat(vars(i),'.',varsFields(j));
                    str3 = ')';
                    str4 = char(strcat(str1,str2,str3));
                    f= evalin('base',str4); 
                    if f == 1,
                       str=[str; str2];
                    end;
                    str1 = 'ischar(';
                    str4 = char(strcat(str1,str2,str3));
                    f= evalin('base',str4); 
                    if f == 1,
                       str=[str; str2];
                    end;
                    str1 = 'iscell(';
                    str4 = char(strcat(str1,str2,str3));
                    f= evalin('base',str4); 
                    if f == 1,
                       str=[str; str2];
                    end;
                    
                end;
            end;
        end;
        
        set(handles.VariablesList,'String',str);
        set(handles.VariablesList,'value',1);
                
        %MAKE VARIABLES AS GLOBALS
        evalin('base','save tmp; clear');
        str1 = {'global '};
        str3 = {';'};
        for i=1:v,
            str2 = vars(i);
            str4 = char(strcat(str1,str2,str3));
            eval(str4); 
            evalin('base',str4);
        end;
        evalin('base','load tmp');
        output=1;
    else
            set(handles.VariablesList,'String','No variables are available');
            set(handles.VariablesList,'value',1);
            data = 0;
    end;
    set(gcbf,'Pointer','arrow');

return;


% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Help_Callback(hObject, eventdata, handles)
% hObject    handle to Help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function HelpMenu_Callback(hObject, eventdata, handles)
% hObject    handle to HelpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    %WINDOWS COMPILED RELEASE
    %system('"C:\Program Files\internet explorer\iexplore"  psico.fcep.urv.cat\utilitats\CorrespondenceAnalysis');
    
    %MATLAB RELEASE
    web('psico.fcep.urv.cat\utilitats\CorrespondenceAnalysis');

% --------------------------------------------------------------------
function AboutMCar_Callback(hObject, eventdata, handles)
% hObject    handle to AboutMCar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
     Data=64:-1:1;Data=(Data'*Data)/64;
     h=msgbox('MultipleCar (version: 6.01)                                                     Urbano Lorenzo-Seva (Rovira i Virgili University, Tarragona, Spain), &   Michel van de Velden (Erasmus University, Rotterdam, The Netherlands),                      Tarragona - 2017 ','About MultipleCar','custom',Data,hot(64));

% --------------------------------------------------------------------
function Open_Callback(hObject, eventdata, handles)
	try       
        evalin('base','clear');
%        evalin('base','uiload');
        evalin('base','uiopen(''matlab'')');
        evalin('base','clear ans me');
        evalin('base','clc');
        f = ActualizeListVariables(handles);
        if (f==1) ,
        set(handles.VariablesList,'value',1);
        
            set(handles.VarData,'string','');
            set(handles.VarCategories,'string','');
            set(handles.VarLabels,'string','');
            set(handles.ButtonData,'string','>');        
            set(handles.CategoriesButton,'string','>');        
            set(handles.LabelsButton,'string','>');        
            set(handles.VarCategories,'string','');
            set(handles.CategoriesButton,'string','>');
            set(handles.SupplementaryPoints,'string','');
            set(handles.DataType,'value',1);
            set(handles.NumberOfDimensions,'string','0');
            set(handles.Model4,'value',1);
            set(handles.Model3,'value',0);
            set(handles.ComputeRotation,'value',0);
            set(handles.WeightsRotation,'enable','on');
            set(handles.WeightsRotation,'value',1);
            set(handles.RotationMethod,'enable','on');
            set(handles.RotationMethod,'value',1);
            set(handles.DetailedOutput,'value',0);
            set(handles.ShowMap,'value',1);
            set(handles.AssessDimesionality,'value',1);
            set(handles.ParallelAnalysis,'value',0);
            set(handles.ShowVariablesMap,'value',1);
            set(handles.ShowIndividualsMap,'value',0);
            set(handles.ShowVariablesIndividualsMap,'value',0);
            set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);
            set(handles.ShowMap,'enable','on');
            set(handles.MapVariables,'value',1);
            set(handles.MapVariablesObservations,'value',0);
            set(handles.MapVariables,'enable','on');
            set(handles.MapVariablesObservations,'enable','on');
          
            evalin('base','clc');
            
        else,
            msgbox('The file is empty','MultipleCar','error');
            set(handles.VariablesList,'String','No variables are available');
            set(handles.VariablesList,'value',1);
            return;    
        end;
	catch
		disp(lasterr);
	end


% --------------------------------------------------------------------
function OpenAscii_Callback(hObject, eventdata, handles)
% hObject    handle to OpenAscii (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    fig = mitd;
    
    %UPDAT THE LIST OF AVAILABLE VARIABLES
    evalin('base','clear ans me');
    evalin('base','clc');
    vars = evalin('base','who');
    set(handles.VariablesList,'String',vars);
    set(handles.VariablesList,'value',1);        


% --------------------------------------------------------------------
function OpenTextLabels_Callback(hObject, eventdata, handles)
% hObject    handle to OpenTextLabels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    fig = MReadLabels;
    
    %UPDAT THE LIST OF AVAILABLE VARIABLES
    evalin('base','clear ans me');
    evalin('base','clc');
    vars = evalin('base','who');
    set(handles.VariablesList,'String',vars);
    set(handles.VariablesList,'value',1);        
return
% --------------------------------------------------------------------
function Save_Callback(hObject, eventdata, handles)
% hObject    handle to Save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
	try
       evalin('base','uisave');
	catch
		disp(lasterr);
	end
return;

% --------------------------------------------------------------------
function ClearData_Callback(hObject, eventdata, handles)
% hObject    handle to ClearData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    ButtonName=questdlg('Do you want to clear the data in memory','Correspondence Analysis'); 
    switch ButtonName
    case {'No','Cancel'}
	    % take no action
    case 'Yes'
        evalin('base','clear');
        evalin('base','clc');
        set(handles.VariablesList,'String','No variables are available');
        set(handles.VariablesList,'value',1);
        
        set(handles.VarData,'string','');
        set(handles.VarCategories,'string','');
        set(handles.VarLabels,'string','');
        set(handles.ButtonData,'string','>');        
        set(handles.CategoriesButton,'string','>');        
        set(handles.LabelsButton,'string','>');        
        set(handles.VarCategories,'string','');
        set(handles.CategoriesButton,'string','>');
        set(handles.SupplementaryPoints,'string','');
        set(handles.DataType,'value',1);
        set(handles.NumberOfDimensions,'string','0');
        set(handles.Model4,'value',1);
        set(handles.Model3,'value',0);
        set(handles.ComputeRotation,'value',1);
        set(handles.WeightsRotation,'enable','on');
        set(handles.WeightsRotation,'value',1);
        set(handles.RotationMethod,'enable','on');
        set(handles.RotationMethod,'value',1);
        set(handles.DetailedOutput,'value',0);
        set(handles.ShowMap,'value',1);
        set(handles.AssessDimesionality,'value',1);
        set(handles.ParallelAnalysis,'value',0);
        set(handles.ShowMap,'enable','on');
        set(handles.MapVariables,'value',1);
        set(handles.MapVariablesObservations,'value',0);
        set(handles.MapVariables,'enable','on');
        set(handles.MapVariablesObservations,'enable','on');
        set(handles.DataType,'enable','on');
        set(handles.DataType,'value',1);
        
    end   
    
return;
    

% --------------------------------------------------------------------
function Quit_Callback(hObject, eventdata, handles)
% hObject    handle to quit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    ButtonName=questdlg('Do you want to quit the application','MultipleCar'); 
    switch ButtonName
    case {'No','Cancel'}
	    % take no action
    case 'Yes'
        delete(gcf);
    end    
return;

function output=ClearFields(str)
 
      strclean={};
      strclean='';
      
      c=char(str);
      [tmp,v]=size(c);
      
      for i=1:v,
          if c(i) ~= '.',
             strclean=strcat(strclean,c(i));
          else
              output=strclean;
              return;
          end;
      end;
      
      output=strclean;
      return;
% --------------------------------------------------------------------

function output=ClearInformationColumns(str)
 
      strclean={};
      strclean=' ';
      
      c=char(str);
      [tmp,v]=size(c);
      
      for i=1:v,
          if c(i) ~= '(',
             strclean=strcat(strclean,c(i));
          else
              output=strclean;
              return;
          end;
      end;
      
      output=strclean;
return;
      

% --- Executes on button press in ShowData.
function ShowData_Callback(hObject, eventdata, handles)
% hObject    handle to ShowData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    str2 = get(handles.VarData,'string');
    
    if isempty(str2),
        msgbox('A variable must be selected','MultipleCar','error');
        return
    end;
    
    %CHECKS IF IT IS A MATRIX
    str1 = {'global '};
    str2 = ClearInformationColumns(str2);
    str3 = {';'};
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    str1 = '[f1, f2]=size(';
    str2 = str2;
    str3 = ');';
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    if f2 < 2 ,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable must be a matrix','MultipleCar: correspondence analysis with rotations','error');
        return;
    end;
    if f1 < 2 ,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable must be a matrix','MultipleCar: correspondence analysis with rotations','error');
        return;
    end;
    
    f=figure('Menubar', 'none','Toolbar','Figure','Name','Data matrix','units','normalized','Position',[0 0.2 .5 .70]);
    str1 ={'uitable(''parent'', f,''units'',''normalized'',''Position'', [.0 .1 1 .9], ''Data'', '};
    str3 ={');'};
    str4 = char(strcat(str1,str2,str3));
    eval(str4);
    
return;


% --- Executes on button press in ShowLabels.
function ShowLabels_Callback(hObject, eventdata, handles)
% hObject    handle to ShowLabels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    str2 = get(handles.VarLabels,'string');
    
    if isempty(str2),
        msgbox('A variable must be selected','MultipleCar','error');
        return
    end;
    
    %CHECKS IF IT IS A MATRIX
    str1 = {'global '};
    str0 = ClearFields(str2);
    str3 = {';'};
    str4 = char(strcat(str1,str0,str3));
    eval(str4); 
    str1 = '[f1, f2]=size(';
    str2 = str2;
    str3 = ');';
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    tmp=char('labels');
    f=figure('Menubar', 'none','Toolbar','Figure','Name','Labels of Categories','units','normalized','Position',[.2 0.2 .20 .70]);
    str1 ={'uitable(''parent'', f,''units'',''normalized'',''ColumnName'',tmp,''Position'', [.0 .1 1 .9], ''Data'', '};

    if f1 > f2 ,
       str3 ={');'};
    else,
       str3 ={''');'};
    end;
    str4 = char(strcat(str1,str2,str3));
    eval(str4);
return;
    


% --- Executes on button press in ShowCategories.
function ShowCategories_Callback(hObject, eventdata, handles)
% hObject    handle to ShowCategories (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


    str2 = get(handles.VarCategories,'string');
    
    if isempty(str2),
        msgbox('A variable must be selected','MultipleCar','error');
        return
    end;
    
    %CHECKS IF IT IS A MATRIX
    str1 = {'global '};
    str2 = ClearInformationColumns(str2);
    str3 = {';'};
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    str1 = '[f1, f2]=size(';
    str2 = str2;
    str3 = ');';
    str4 = char(strcat(str1,str2,str3));
    eval(str4); 
    tmp=char('Categories');
    f=figure('Menubar', 'none','Toolbar','Figure','Name','Number  of Categories per Variable','units','normalized','Position',[.2 0.2 .25 .70]);
    str1 ={'uitable(''parent'', f,''units'',''normalized'',''ColumnName'',tmp,''Position'', [.0 .1 1 .9], ''Data'', '};

    if f1 > f2 ,
       str3 ={');'};
    else,
       str3 ={''');'};
    end;
    str4 = char(strcat(str1,str2,str3));
    eval(str4);
return;



function SupplementaryPoints_Callback(hObject, eventdata, handles)
% hObject    handle to SupplementaryPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SupplementaryPoints as text
%        str2double(get(hObject,'String')) returns contents of SupplementaryPoints as a double


% --- Executes during object creation, after setting all properties.
function SupplementaryPoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SupplementaryPoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NumberOfDimensions_Callback(hObject, eventdata, handles)
% hObject    handle to NumberOfDimensions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NumberOfDimensions as text
%        str2double(get(hObject,'String')) returns contents of NumberOfDimensions as a double


% --- Executes during object creation, after setting all properties.
function NumberOfDimensions_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NumberOfDimensions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Model0.
function Model4_Callback(hObject, eventdata, handles)
% hObject    handle to Model0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Model0
    set(handles.Model4,'value',1);
    set(handles.Model3,'value',0);
    
    tmp=get(handles.DataType,'Value');
    %CHECKS IF IT IS NOT A BURT MATRIX
    if (tmp ~= 3),
       set(handles.ShowVariablesMap,'enable','on');
       set(handles.ShowIndividualsMap,'enable','on');
       set(handles.ShowVariablesIndividualsMap,'enable','on');
       set(handles.ShowVariablesIndividualsMap_EqualSpread,'enable','on');
           tmp2 = get(handles.ShowMap,'value');
           if tmp2 == 1,
              set(handles.MapVariables,'value',1);
              set(handles.MapVariablesObservations,'value',0);
              set(handles.MapVariables,'enable','on');
              set(handles.MapVariablesObservations,'enable','on');
           end;
    else,
        %Burt matrix
        tmp2 = get(handles.ShowMap,'value');
        if tmp2 == 1,
           set(handles.MapVariables,'value',1);
           set(handles.MapVariablesObservations,'value',0);
           set(handles.MapVariables,'enable','on');
           set(handles.MapVariablesObservations,'enable','off');
        end;
    end;
    
return;

% --- Executes on button press in Model3.
function Model3_Callback(hObject, eventdata, handles)
% hObject    handle to Model3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Model3
    set(handles.Model4,'value',0);
    set(handles.Model3,'value',1);
    set(handles.ShowVariablesMap,'enable','on');
    set(handles.ShowIndividualsMap,'enable','off');
    set(handles.ShowVariablesIndividualsMap,'enable','off');
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'enable','off');
    set(handles.ShowVariablesMap,'value',1);
    set(handles.ShowIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);
    
    tmp = get(handles.ShowMap,'value');
    if tmp == 1,
       set(handles.MapVariables,'value',1);
       set(handles.MapVariablesObservations,'value',0);
       set(handles.MapVariables,'enable','on');
       set(handles.MapVariablesObservations,'enable','off');
    end;
    
return;


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over VariablesList.
function VariablesList_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to VariablesList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
     s    = get(handles.VariablesList,'value');
     str  = get(handles.VariablesList,'string');

     %CHECKS IF THE MATRIX EXISTS IN THE WORK MEMORY SPACE
    str1 = 'exist(''';
    str2=ClearFields(str(s));
    str3 = ''',''var'')';
    str4 = char(strcat(str1,str2,str3));
    
    f = evalin('base',str4);
    if f == 0,
        set(gcbf,'Pointer','arrow');
        msgbox('The variable is not anymore available in the work memory space','MultipleCar','error');
        ActualizeListVariables(handles);
        return;
    end;
    
    if isempty(str2),
        msgbox('A variable must be selected','MultipleCar','error');
        return
    end;
   
    f=figure('Menubar', 'none','Toolbar','Figure','Name','Data matrix','units','normalized','Position',[0 0.2 .95 .70]);
    str1 ={'uitable(''units'',''normalized'',''Position'', [.0 .1 1 .9], ''Data'', '};
    str3 ={');'};
    str4 = char(strcat(str1,str(s),str3));
    evalin('base',str4);
    return;


% --- Executes on selection change in WeightsRotation.
function WeightsRotation_Callback(hObject, eventdata, handles)
% hObject    handle to WeightsRotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns WeightsRotation contents as cell array
%        contents{get(hObject,'Value')} returns selected item from WeightsRotation


% --- Executes during object creation, after setting all properties.
function WeightsRotation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WeightsRotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function RotationMethod_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RotationMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ParallelAnalysis.
function ParallelAnalysis_Callback(hObject, eventdata, handles)
% hObject    handle to ParallelAnalysis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ParallelAnalysis


% --- Executes on button press in DetailedOutput.
function DetailedOutput_Callback(hObject, eventdata, handles)
% hObject    handle to DetailedOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of DetailedOutput



function OutputFile_Callback(hObject, eventdata, handles)
% hObject    handle to OutputFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of OutputFile as text
%        str2double(get(hObject,'String')) returns contents of OutputFile as a double


% --- Executes during object creation, after setting all properties.
function OutputFile_CreateFcn(hObject, eventdata, handles)
% hObject    handle to OutputFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Compute.
function Compute_Callback(hObject, eventdata, handles)
% hObject    handle to Compute (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    
    %LOAD DATA
    me.data=getappdata(0,'data');

    %Data Analaysis initialitation
    me.data.I=0;
    me.data.J=0;
    me.data.N=[];
    me.data.labels.x={};
    me.data.labels.y={};
    me.data.raw.x=[];
    me.data.raw.y=[];
    me.data.model.k=0;
    me.data.model.coordinates=0;
    me.data.rotation.compute=0;
    me.data.rotation.weights=0;
    me.data.rotation.method=0;
    me.data.MCA.supplementary=0;
    me.data.MCA.k=0;
    me.data.MCA.Q=0;    
    me.data.MCA.model=0;
    me.data.MCA.rotation=0;
    me.data.MCA.rawdata=[];
    me.data.MCA.M=[];
    me.data.MCA.X=[];
    me.data.MCA.Z=[];
    me.data.MCA.B=[];
    me.data.MCA.Msup=[];
    me.data.MCA.Xsup=[];
    me.data.MCA.Zsup=[];
    me.data.MCA.Bsup=[];
    me.data.MCA.labels={};
    me.data.MCA.labels_sup={};
    
    me.OutputFile = get(handles.OutputFile,'string');
    
    %TO CHECK IF A FILE NAME HAS BEEN ASIGNED
    if isempty(strcat(' ',char(me.OutputFile))),
        msgbox('You must indicate the name of the output file.','CAR: Correspondence analysis with rotations','error');
        return;
    end;
   
    evalin('base','clc');
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Get vector M with number of categories
    me.data.raw.x = [];
    me.data.raw.y = [];
    me.M=get(handles.VarCategories,'string');

    %CHECK IF VARIABLES HAVE BEEN ASSIGNED
    if isempty(me.M),
        msgbox('You must indicate the variable that contains the number of categories per variable','MultipleCar','error');
        return;
    end;

    %DECLARE BASE VARIABLES AS GLOBALS 
    me.str1 = {'global '};
    me.str2=ClearFields(me.M);
    me.str3 = {';'};
    me.str4 = char(strcat(me.str1,me.str2,me.str3));
    eval(me.str4); 

    %TO ASSIGN MATRIX M
    me.str1 = 'me.data.MCA.M = ';
    me.str3 = {';'};
    me.str4 = char(strcat(me.str1,me.M,me.str3));
    eval(me.str4);
    [tmp1,tmp2]=size(me.data.MCA.M );
    if tmp1>tmp2,
        me.data.MCA.M  = me.data.MCA.M';
    end;

    [tmp,me.data.MCA.n_var]=size(me.data.MCA.M); %number of variables
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Get DATA
    %CHECK IF VARIABLES HAVE BEEN ASSIGNED
    me.rawdata=get(handles.VarData,'string');

    if isempty(me.rawdata),
        msgbox('You must indicate the variable that contains rawdata, indicator matrix, or Burt matrix','MultipleCar','error');
        return;
    end;

    %DECLARE BASE VARIABLES AS GLOBALS 
    me.str1 = {'global '};
    me.str2=ClearFields(me.rawdata);
    me.str3 = {';'};
    me.str4 = char(strcat(me.str1,me.str2,me.str3));
    eval(me.str4); 
   
    tmp=get(handles.DataType,'Value');
    %RAW DATA
    if (tmp == 1),
        %TO ASSIGN MATRIX X
        me.str1 = 'me.data.MCA.X = ';
        me.str3 = {';'};
        me.str4 = char(strcat(me.str1,me.rawdata,me.str3));
        eval(me.str4);
        %to check if sizes of M and X are coherent
        [tmp2,tmp1]=size(me.data.MCA.X);
        if (tmp1 > tmp2),
            msgbox('The number of variables is larger than the number of observations. At least the same number of observation as variables is needed','MultipleCar','error');
            return;            
        end;        
        if (tmp1 ~= me.data.MCA.n_var),
            msgbox('The number of categories per variable is not coherent with the raw data. Please, check the number of categories per variable','MultipleCar','error');
            return;            
        end;
        %the lowest value is a 1 and the maximun cannot be larger than the
        %number of categories in M
        for i=1:me.data.MCA.n_var
            tmp3=min(me.data.MCA.X(:,i));
            if tmp3 < 1,
                me.data.MCA.X(:,i) = me.data.MCA.X(:,i) + tmp + 1;
            end;
            tmp3=max(me.data.MCA.X(:,i));
            if tmp3 > me.data.MCA.M(:,i),
                msgbox('The number of categories per variable is not coherent with the raw data. Please, check the number of categories per variable','MultipleCar','error');
                return;
            end;
        end;    

        %Has indicator matrix been previously computed?
        global MCAR_Indicator_Matrix;
        calcularIndicator=0;
        if isempty(MCAR_Indicator_Matrix),
           calcularIndicator = 1;
        else,
          if isnumeric(MCAR_Indicator_Matrix)==0,    
            calcularIndicator = 1;
          else,
             [tmp1,tmp2]=size(MCAR_Indicator_Matrix);
             tmp3=abs(max(sum(MCAR_Indicator_Matrix')') - min(sum(MCAR_Indicator_Matrix')'));  
             [tmp4,tmp5]=size(me.data.MCA.X);
             tmp6 = sum(me.data.MCA.M');
             if min(tmp1,tmp2) < 2,
                calcularIndicator = 1;
             elseif tmp3 == 1;
                calcularIndicator = 1;
             elseif tmp1 ~= tmp4,
                calcularIndicator = 1;
             elseif tmp2 ~= tmp6,
                calcularIndicator = 1;                 
             end;
          end;
        end;
        if calcularIndicator==0,
           me.data.MCA.Z=MCAR_Indicator_Matrix; 
           evalin('base','global MCAR_Indicator_Matrix');
           ActualizeListVariables(handles);
        else,
            %To compute the indicator matrix from raw data
            [tmp1,tmp2]=size(me.data.MCA.X);
            me.data.MCA.Z=[];

            tstart = tic;
            tmp3 = 0; bar1 = waitbar(tmp3,'Indicator matrix');
            for i=1:tmp1,
                II=[];
                again = 1;
                for j=1:tmp2,
                    H=eye(me.data.MCA.M(1,j));
                    II=[II H(me.data.MCA.X(i,j),:)];
                    tmp3 = tmp3+1;
                    if again == 1,
                            compT = toc(tstart);
                            compT = compT*tmp1*tmp2/tmp3 - compT;
                            compH = floor(compT/(60*60));
                            compT2 = compT - compH*60*60;
                            compM = floor((compT2)/60);
                            compS = round(compT2 - compM*60);
                            if compH > 0,
                                buff=sprintf('%.0f:%.0f:%.0f',compH, compM,compS);    
                            elseif compM > 10,
                                buff=sprintf('00:%.0f:%.0f',compM,compS);    
                            elseif compM > 1,
                                buff=sprintf('00:0%.0f:%.0f',compM,compS);    
                            else,
                                buff=sprintf('%.0f seconds',compS);    
                            end;
                            if compS>1,
                               s_tmp=['Indicator matrix (Remaining time = ' buff ')'];
                               waitbar(tmp3/(tmp1*tmp2),bar1,s_tmp);
                            elseif compS==1,
                               s_tmp=['Indicator matrix (Remaining time = 1 second)'];
                               waitbar(tmp3/(tmp1*tmp2),bar1,s_tmp);
                            else,
                               s_tmp=['Indicator matrix (already finishing)'];
                               waitbar(tmp3/(tmp1*tmp2),bar1,s_tmp);
                            end;
                            again = 0;
                    end;
                    again = 1;
                end;
                me.data.MCA.Z=[me.data.MCA.Z;II];
            end;
            close(bar1);
            clear tmp1 tmp2 tmp3 i j H II tstart bar1 compT compH compT2 compM compS buff s_tmp again;
            MCAR_Indicator_Matrix=me.data.MCA.Z;
            evalin('base','global MCAR_Indicator_Matrix');
            ActualizeListVariables(handles);
        end;
        
        %TO COMPUTE BURT MATRIX from Z
        me.data.MCA.B = me.data.MCA.Z'*me.data.MCA.Z;        
        [me.data.I,me.data.J]=size(me.data.MCA.Z);
        global MCAR_Burt_Matrix;
        MCAR_Burt_Matrix=me.data.MCA.B;
        evalin('base','global MCAR_Burt_Matrix');
        ActualizeListVariables(handles);

    elseif (tmp == 2),
        %TO ASSIGN MATRIX Z 
        me.data.MCA.X=[];
        me.str1 = 'me.data.MCA.Z = ';
        me.str3 = {';'};
        me.str4 = char(strcat(me.str1,me.rawdata,me.str3));
        eval(me.str4);
        %TO ASSIGN SIZES: ready to compute a simple CA from Z
        [me.data.I,me.data.J]=size(me.data.MCA.Z);
        %to check if sizes of M and Z are coherents
        tmp=sum(sum(me.data.MCA.Z')')/me.data.MCA.n_var;
        if tmp ~= me.data.I,
            msgbox('The values in the indicator matrix are not coherent with the number of categories per variable. Please, remember that missing values are not allowed.','MultipleCar','error');
            return;
        end;
        %TO ASSIGN SIZES
        [me.data.I,me.data.J]=size(me.data.MCA.Z);        
        %TO COMPUTE BURT MATRIX from Z
        me.data.MCA.B = me.data.MCA.Z'*me.data.MCA.Z;
        global MCAR_Burt_Matrix;
        MCAR_Burt_Matrix=me.data.MCA.B;
        evalin('base','global MCAR_Burt_Matrix');
        ActualizeListVariables(handles);
        
    elseif (tmp == 3),
        %TO ASSIGN MATRIX B 
        me.data.MCA.X=[];
        me.data.MCA.Z=[];
        me.str1 = 'me.data.MCA.B = ';
        me.str3 = {';'};
        me.str4 = char(strcat(me.str1,me.rawdata,me.str3));
        eval(me.str4);
        %to check if burt matrix and the number of categories are coherent
        [tmp2,tmp1]=size(me.data.MCA.B);
        tmp2 = sum(me.data.MCA.M');
        if tmp1 ~= tmp2,
            msgbox('The values in the Burt matrix are not coherent with the number of categories per variable. Please, check the number of categories per variable.','MultipleCar','error');
            return;            
        end;
        %to check a burt matrix if M is available
        tmp1= trace(me.data.MCA.B(1:me.data.MCA.M(1,1),1:me.data.MCA.M(1,1)))*me.data.MCA.n_var;
        tmp2=trace(me.data.MCA.B);
        if tmp1 ~= tmp2,
            msgbox('The values in the Burt matrix are not coherent with the number of categories per variable. Please, check the number of categories per variable.','MultipleCar','error');
            return;            
        end;
        tmp3=me.data.MCA.M(1,1);
        for i=2:me.data.MCA.n_var-1,
            tmp4=tmp3 + me.data.MCA.M(1,i);
            tmp1= trace(me.data.MCA.B((tmp3+1):tmp4,(tmp3+1):tmp4))*me.data.MCA.n_var;
            if tmp1 ~= tmp2,
                msgbox('The values in the Burt matrix are not coherent with the number of categories per variable. Please, check the number of categories per variable.','MultipleCar','error');
                return;            
            end;
            tmp3= tmp4;
        end;
        %To assign sizes
        [me.data.I,me.data.J]=size(me.data.MCA.B);        
    end;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Get labels
    %TO ASSIGN LABELS
    me.RL = get(handles.VarLabels,'string');
    if isempty(me.RL),
        tmp=[];
        for i=1:me.data.MCA.n_var,
            tmp =[tmp; [1:me.data.MCA.M(1,i)]'];
        end;
        me.data.MCA.labels=cellstr(num2str(tmp));
        clear tmp;
    else
        me.str1 = {'global '};
        me.str2=ClearFields(me.RL);
        me.str3 = {';'};
        me.str4 = char(strcat(me.str1,me.str2,me.str3));
        eval(me.str4); 
        me.str1 = 'me.data.MCA.labels = ';
        me.str3 = {';'};
        me.str4 = char(strcat(me.str1,me.RL,me.str3));
        eval(me.str4);
    end;
    %CHECK LABELS BEFORE COMPUTING
    [me.f1,me.f2]=size(me.data.MCA.labels);
    if me.f1<me.f2,
       me.data.MCA.labels=me.data.MCA.labels';
       me.f1=me.f2;
    end;
    if me.f1 ~=sum(me.data.MCA.M'),
        msgbox('Labels are not coherent with the number of categories per variables. Please check the variable assigned as "Labels"','MultipleCar','error');
        return
    end;
    %labels for individuals in model 0
    tmp = [1:me.data.I]';
    me.data.labels.x =cellstr(num2str(tmp));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Get supplementary variables
    %GET SUPPLEMENTARY VARIABLES
    me.sup=0;
    me.SuppleVar = get(handles.SupplementaryPoints,'string');
    if isempty(me.SuppleVar),
        %Number of variables that define the space
        me.data.MCA.Q = me.data.MCA.n_var;
    else        
      me.SupVarIndex = floor(sort(str2num(me.SuppleVar)));
      if isempty(me.SupVarIndex),
        msgbox('I do not understand the indices of the supplementary variables','MultipleCar','error');
        return
      end;
      if min(me.SupVarIndex) < 1,
        msgbox('Indices of the supplementary variables have to be numbers larger than zero','MultipleCar','error');
        return
      end;
      if max(me.SupVarIndex) > me.data.MCA.n_var,
        msgbox('The indices of the supplementary variables cannot be larger than the number of variables','MultipleCar','error');
        return
      end;
      %select non-supplementary and supplementary variables
      me.NoSupVarIndex=[];
      for i=1:me.data.MCA.n_var,
          [me.tmp1,me.tmp2]=size(me.SupVarIndex);
          me.tmp3=1;
          for j=1:me.tmp2,
              if me.SupVarIndex(j)==i,
                  me.tmp3=0;
              end;
          end;
          if me.tmp3==1,
             me.NoSupVarIndex=[me.NoSupVarIndex i]; 
          end;
      end;
      [me.f1,me.tmp]=size(me.NoSupVarIndex');
      [me.f2,me.tmp]=size(me.SupVarIndex');
      if me.f1 < me.f2,
        msgbox('You are not allowed to have so much supplementary variables','MultipleCar','error');
        return
      end;
      if me.f1 < 2,
        msgbox('You are not allowed to have so many supplementary variables','MultipleCar','error');
        return
      end;
      %select non-suplementary categories
      me.NoSupCat=[];
      if me.f1>1,
          for j=1:me.data.MCA.n_var,
             if j==1,
                 tmp1=1;
                 tmp2=me.data.MCA.M(1,1);
             else,
                 tmp1 = tmp2+1;
                 tmp2= tmp1 + me.data.MCA.M(1,j)-1;
             end;
             tmp3=0;
             for i=1:me.f1,
                 if j == me.NoSupVarIndex(i),
                     tmp3=1;
                 end;
             end;
             if tmp3==1,
                 me.NoSupCat=[me.NoSupCat [tmp1:tmp2]];
             end;
          end;        
      end;
      %select suplementary categories
      me.SupCat=[];
      if me.f2>0,
          for j=1:me.data.MCA.n_var,
             if j==1,
                 tmp1=1;
                 tmp2=me.data.MCA.M(1,1);
             else,
                 tmp1 = tmp2+1;
                 tmp2= tmp1 + me.data.MCA.M(1,j)-1;
             end;
             tmp3=0;
             for i=1:me.f2,
                 if j == me.SupVarIndex(i),
                     tmp3=1;
                 end;
             end;
             if tmp3==1,
                 me.SupCat=[me.SupCat [tmp1:tmp2]];
             end;
          end;        
      end;
      me.data.MCA.Msup       = me.data.MCA.M(1,me.SupVarIndex);
      me.data.MCA.M          = me.data.MCA.M(1,me.NoSupVarIndex);
      me.data.MCA.Bsup       = me.data.MCA.B(me.NoSupCat,me.SupCat);
      me.data.MCA.B          = me.data.MCA.B(me.NoSupCat,me.NoSupCat);
      if isempty(me.data.MCA.Z) == 0,
         me.data.MCA.Zsup       = me.data.MCA.Z(:,me.SupCat);
         me.data.MCA.Z          = me.data.MCA.Z(:,me.NoSupCat);
        [me.data.I,me.data.J]=size(me.data.MCA.Z);        
      else,
        [me.data.I,me.data.J]=size(me.data.MCA.B);                  
      end;
      if isempty(me.data.MCA.X) == 0,
         me.data.MCA.Xsup       = me.data.MCA.X(:,me.SupVarIndex);
         me.data.MCA.X          = me.data.MCA.X(:,me.NoSupVarIndex);
      end;       
      
      [tmp,me.data.MCA.Q] = size(me.data.MCA.M);
      me.data.MCA.labels_sup = me.data.MCA.labels(me.SupCat);
      me.data.MCA.labels     = me.data.MCA.labels(me.NoSupCat);
      me.sup=1;   
      me.data.MCA.supplementary=me.f2;
    end;
  
    %GET NUMBER DIMENSIONS
    me.data.MCA.k=0;
    me.k = str2double(get(handles.NumberOfDimensions,'string'));
    if me.k <1,
       prompt={'You must indicate the number of dimension to retain. Frequently, two dimensions are retained. However, you can consider other dimensionalities.                                    Number of dimensions:'};
       def={'2'};
       dlgTitle='Number of dimensions to retain';
       lineNo=1;
       answer=inputdlg(prompt,dlgTitle,lineNo,def);
       if isempty(answer),
           return
       end;
       me.k = str2num(char(answer(1)));
       set(handles.NumberOfDimensions,'string',answer(1));
    end;
    me.maxK = me.data.J-me.data.MCA.Q;
    if me.k > me.maxK,
        me.str= sprintf('The maximun number of dimensions is %.0f.',me.maxK);
        msgbox(me.str,'MultipleCar','error');
        return
    end;
    me.data.MCA.k=me.k;
      
    %GET MODEL MCA (FROM INDICATOR OR BURT) OR JCA
    me.data.MCA.model=3;
    if get(handles.Model4,'value') == 1,
        if get(handles.ShowVariablesMap,'value')==1,
           tmp=get(handles.DataType,'Value');
           if tmp == 3,
              %MCA-B (only Variables are studied)
              me.data.MCA.model=5;   
           else,
              %MCA-I (Variables as principal)
              me.data.MCA.model=9;   
           end;
        end;
        if get(handles.ShowIndividualsMap,'value')==1,
           %MCA-I (Individuals as principal coordinates )
           me.data.MCA.model=6;     
        end;
        if get(handles.ShowVariablesIndividualsMap,'value')==1,
           %MCA-I (both Individuals and Variables as principal coordinates)
           me.data.MCA.model=7;     
        end;
        if get(handles.ShowVariablesIndividualsMap_EqualSpread,'value')==1,
           %MCA-I (both Individuals and Variables as principal coordinated with equal spread)
           me.data.MCA.model=8;     
        end;
        
    end;
    %JCA
    if get(handles.Model3,'value') == 1,
       me.data.MCA.model=4;
    end;

    %GET ROTATION
    if me.k > 1,
        me.data.rotation.compute=get(handles.ComputeRotation,'value');
        if me.data.rotation.compute == 1,       
            me.data.rotation.weights = get(handles.WeightsRotation,'value');
            me.data.MCA.rotation=get(handles.RotationMethod,'value');
        end;
    end;
    
    %SAVE DATA 
    setappdata(0,'data',me.data);

    try
        %CLEAR OUTPUT FILE
        fid=fopen(char(me.OutputFile),'w');
        fwrite(fid,' ');
        fclose(fid);

        %WRITE OUTPUT
        me.str=sprintf('diary %s;',char(me.OutputFile));
        eval(me.str);
    catch
       disp(lasterr); 
    end;
    
    
    set(gcbf,'Pointer','watch');

   %COMPUTING
   try
       me.t0 = clock;

       %MODEL 1 = CA directly from Z 
       if me.data.MCA.model== 1,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Zsup;
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.output=canalysis(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysis(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels);
           end; 
           %adjustements of a CA based on Z
           me.output = MaxKCA_2_MaxKMCA( me.output,me.maxK );
           %French symmetrical model
           me.data.model.coordinates = 4; 
           setappdata(0,'data',me.data);
       end;

       %MODEL 2 = CA from Burt matrix
       if me.data.MCA.model== 2,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Bsup;
               me.supp_struct.r=me.data.MCA.Bsup';
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.supp_labels_struct.r=me.data.MCA.labels_sup;
               me.output=canalysis(me.data.MCA.B,me.data.MCA.k,me.data.MCA.labels,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysis(me.data.MCA.B,me.data.MCA.k,me.data.MCA.labels,me.data.MCA.labels);
           end; 
           %adjustements of a CA based on B
           me.output = MaxKCA_2_MaxKMCA( me.output,me.maxK );
           %model: Columns are principal coordinates, and rows are standard coordinates
           me.data.model.coordinates = 3; 
           setappdata(0,'data',me.data);
       end;

       %MODEL 3 = Adjusted CA from Burt matrix
       if me.data.MCA.model== 3,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Bsup;
               me.supp_struct.r=me.data.MCA.Bsup';
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.supp_labels_struct.r=me.data.MCA.labels_sup;
               me.output=canalysisMCA(me.data.MCA.B,me.data.MCA.k,me.data.MCA.M,me.data.MCA.labels,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysisMCA(me.data.MCA.B,me.data.MCA.k,me.data.MCA.M,me.data.MCA.labels,me.data.MCA.labels);
           end; 
           %model: Columns are principal coordinates, and rows are standard coordinates
           me.data.model.coordinates = 3; 
           setappdata(0,'data',me.data);
       end;

       %MODEL 4 = JOINT CORRESPONDENCE ANALYSIS
       if me.data.MCA.model== 4,
           me.data.MCA.out_jca=JCA (me.data.MCA.B,me.data.MCA.M,me.k);
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Bsup;
               me.supp_struct.r=me.data.MCA.Bsup';
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.supp_labels_struct.r=me.data.MCA.labels_sup;
               me.output=canalysis(me.data.MCA.out_jca.B,me.data.MCA.k,me.data.MCA.labels,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysis(me.data.MCA.out_jca.B,me.data.MCA.k,me.data.MCA.labels,me.data.MCA.labels);
           end; 
           %adjustements of a CA based on B
           me.output = MaxKCA_2_MaxKMCA( me.output,me.maxK );
           %model: Columns are principal coordinates, and rows are standard coordinates
           me.data.model.coordinates = 3; 
           setappdata(0,'data',me.data);
       end;

       %MODEL 5 MCA-B (only variables are plotted (principal coordinates); computed from Burt matrix)
       if me.data.MCA.model== 5,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Bsup;
               me.supp_struct.r=me.data.MCA.Bsup';
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.supp_labels_struct.r=me.data.MCA.labels_sup;
               me.output=canalysisFast(me.data.MCA.B,me.data.MCA.k,me.data.MCA.labels,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysisFast(me.data.MCA.B,me.data.MCA.k,me.data.MCA.labels,me.data.MCA.labels);
           end; 
           if get(handles.AssessDimesionality,'value') == 1,
              me.output = ComputeInertias( me.output,me.maxK  );
              me.output = AdjustedInertias( me.output, me.data.MCA.B, me.data.MCA.M, me.data.MCA.Q);
          end;
           
           %model: Columns are principal coordinates, and rows are standard coordinates                      
           me.data.model.coordinates = 3; 
           setappdata(0,'data',me.data);
       end;
       
       %MODEL 6 MCA-I (individuals are plotted as principal coordinates; computed from Indicator matrix)
       if me.data.MCA.model== 6,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Zsup;
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels);
           end; 
           if get(handles.AssessDimesionality,'value') == 1,
              me.output = ComputeInertias( me.output,me.maxK  );
              me.output = AdjustedInertias( me.output, me.data.MCA.B, me.data.MCA.M, me.data.MCA.Q);
           end;
           
           %model: Rows are principal coordinates, and columns are standard coordinates                      
           me.data.model.coordinates = 2; 
           setappdata(0,'data',me.data);
       end;

       %MODEL 7 MCA-I (individuals and variables are plotted as principal coordinates; computed from Indicator matrix)
       if me.data.MCA.model== 7,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Zsup;
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels);
           end; 
           if get(handles.AssessDimesionality,'value') == 1,
              me.output = ComputeInertias( me.output,me.maxK  );
              me.output = AdjustedInertias( me.output, me.data.MCA.B, me.data.MCA.M, me.data.MCA.Q);
           end;
           
           %model: Rows are principal coordinates, and columns are principal coordinates (French model)                     
           me.data.model.coordinates = 4; 
           setappdata(0,'data',me.data);
       end;
       
       %MODEL 8 MCA-I (biplot model: individuals and variables are plotted as principal coordinates with eaqual spread)
       if me.data.MCA.model== 8,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Zsup;
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels);
           end; 
           if get(handles.AssessDimesionality,'value') == 1,
              me.output = ComputeInertias( me.output,me.maxK  );
              me.output = AdjustedInertias( me.output, me.data.MCA.B, me.data.MCA.M, me.data.MCA.Q);
              
           end;
           
           %model: 1 -> Symmetrical coordinates (biplot)   
           % a=[(I/J)*trace(Ys'Ys)/trace(Xp'Xp)]^(1/4)
           a=(me.output.I/me.output.J*trace(me.output.Y'*me.output.Y)/trace(me.output.F'*me.output.F))^(1/4);
           % a*Xp: symmetrical coordinates for rows
           me.output.H=a*me.output.F;
           % 1/a*Xs: symmetrical coordinates for columns
           me.output.Z=(1/a)*me.output.Y;
           me.data.model.coordinates = 1; 
           setappdata(0,'data',me.data);
       end;
       
       %MODEL 9 MCA-I (variables are plotted as principal coordinates; computed from Indicator matrix)
       if me.data.MCA.model== 9,
           if (me.sup==1),
               me.supp_struct.c=me.data.MCA.Zsup;
               me.supp_labels_struct.c=me.data.MCA.labels_sup;
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels,me.supp_struct,me.supp_labels_struct);
           else,
               me.output=canalysisFast(me.data.MCA.Z,me.data.MCA.k,me.data.labels.x,me.data.MCA.labels);
           end; 
           if get(handles.AssessDimesionality,'value') == 1,
              me.output = ComputeInertias( me.output,me.maxK  );
              me.output = AdjustedInertias( me.output, me.data.MCA.B, me.data.MCA.M, me.data.MCA.Q);
           end;
           
           %model: Column principal coordinates, and rows standard coordinates from a Burt matrix
           me.data.model.coordinates = 5; 
           setappdata(0,'data',me.data);
       end;
       
       setappdata(0,'output',me.output);
       
       %ROTATION
        if me.data.rotation.compute == 1,  
            if me.data.MCA.model== 4,
                if me.data.MCA.rotation == 1,
                   me.data.rotation.method = 3;
                end;
                if me.data.MCA.rotation == 2,
                   me.data.rotation.method = 5;
                end;
            end;
            if me.data.MCA.model== 5,
                if me.data.MCA.rotation == 1,
                   me.data.rotation.method = 3;
                end;
                if me.data.MCA.rotation == 2,
                   me.data.rotation.method = 5;
                end;
            end;
            if me.data.MCA.model== 9,
                if me.data.MCA.rotation == 1,
                   me.data.rotation.method = 3;
                end;
                if me.data.MCA.rotation == 2,
                   me.data.rotation.method = 5;
                end;
            end;
            if me.data.MCA.model== 6,
                if me.data.MCA.rotation == 1,
                   me.data.rotation.method = 3;
                end;
                if me.data.MCA.rotation == 2,
                   me.data.rotation.method = 5;
                end;
            end;
            if me.data.MCA.model== 7,
                if me.data.MCA.rotation == 1,
                   me.data.rotation.method = 1;
                end;
                if me.data.MCA.rotation == 2,
                   me.data.rotation.method = 2;
                end;
            end;
            if me.data.MCA.model== 8,
                if me.data.MCA.rotation == 1,
                   me.data.rotation.method = 1;
                end;
                if me.data.MCA.rotation == 2,
                   me.data.rotation.method = 2;
                end;
            end;

            me.rotation = ComputeRotation(me.output, me.data.MCA.k, me.data.model.coordinates, me.data.rotation.method, me.data.rotation.weights);
            %SAVE ROTATION 
            setappdata(0,'rotation',me.rotation);
        end;

       %SAVE DATA 
       setappdata(0,'data',me.data);
        
       clc;
       disp('------------------------------------------------------------------------- ');
       disp(' ');
       disp('    M U L T I P L E     C O R R E S P O N D E N C E      A N A L Y S I S ');
       disp(' ');
       disp(' ');
       disp('                               MultipleCar version 6.01');
       disp(' ');
       disp(' ');
       disp('  by Urbano Lorenzo-Seva  (Rovira i Virgili University, Tarragona, Spain), &');
       disp('     Michel van de Velden (Erasmus University, Rotterdam, The Netherlands)');
%       disp('     Henk A. L. Kiers     (University of Groningen, Groningen, The Netherlands)');
       disp(' ');
       disp(' ');
       disp('                           Tarragona (Spain) - 2017 ');
       disp(' ');
       disp(' ');
       me.str=sprintf('                          Data: %s',datestr(now));
       disp(me.str);
       me.str=sprintf('                        Computing time: %.3f seconds',etime(clock,me.t0));
       disp(me.str);
       disp(' ');
       disp(' ');
       disp('------------------------------------------------------------------------- ');
       disp(' ');
       disp(' ');
       
       if me.data.MCA.model== 1,
          disp('Model: Multiple correspondence analysis of indicator matrix (MCA-I)');
       elseif me.data.MCA.model== 2,
          disp('Model: Multiple correspondence analysis of Burt matrix (MCA-B)');
       elseif me.data.MCA.model== 3,
          disp('Model: Adjusted multiple correspondence analysis of Burt matrix (AMCA-B)');
       elseif me.data.MCA.model== 4,
          disp('Model: Joint correspondence analysis (JCA)');
          disp('Coordinates:  Variables as Principal Coordinates');
       elseif me.data.MCA.model== 5,
          disp('Model: Multiple correspondence analysis of Burt matrix (MCA-B)');
          disp('Coordinates:  Variables as Principal Coordinates');
       elseif me.data.MCA.model== 6,
          disp('Model: Multiple correspondence analysis of Indicator matrix (MCA-I)');
          disp('Coordinates: Observations as Principal Coordinates and Variables as Standard Coordinates');
       elseif me.data.MCA.model== 7,
          disp('Model: Multiple correspondence analysis of Indicator matrix (MCA-I)');
          disp('Coordinates: French symmetrical coordinates (both Variables and Observations as Principal Coordinates)');
       elseif me.data.MCA.model== 8,
          disp('Model: Multiple correspondence analysis of Indicator matrix (MCA-I)');
          disp('Coordinates: Biplot symmetrical coordinates (both Variables and Observations as Principal Coordinates with equal spread)');
       elseif me.data.MCA.model== 9,
          disp('Model: Multiple correspondence analysis of Indicator matrix (MCA-I)');
          disp('Coordinates: Variables as Principal Coordinates and Observations as Standard Coordinates');
       end;
       disp(' ');
       
       PrintDescriptivesUnivariate(me.data.MCA,me.data.J,get(handles.DetailedOutput,'value'));
       if me.data.MCA.model== 4,
           PrintDescriptivesJCA(me.output,me.data.MCA.out_jca,get(handles.DetailedOutput,'value'),get(handles.ParallelAnalysis,'value'));
       elseif me.data.MCA.model== 5,
           PrintDescriptivesMCA(me.output,me.data.MCA,get(handles.DetailedOutput,'value'),get(handles.ParallelAnalysis,'value'));
           if get(handles.AssessDimesionality,'value') == 1,
              PrintInertiasMCA(me.output,get(handles.DetailedOutput,'value'));
           end;
       elseif me.data.MCA.model== 9,
           PrintDescriptivesMCA(me.output,me.data.MCA,get(handles.DetailedOutput,'value'),get(handles.ParallelAnalysis,'value'));
           if get(handles.AssessDimesionality,'value') == 1,
              PrintInertiasMCA(me.output,get(handles.DetailedOutput,'value'));
           end;
       elseif me.data.MCA.model== 6,
           PrintDescriptivesMCA(me.output,me.data.MCA,get(handles.DetailedOutput,'value'),get(handles.ParallelAnalysis,'value'));
           if get(handles.AssessDimesionality,'value') == 1,
              PrintInertiasMCA(me.output,get(handles.DetailedOutput,'value'));
           end;
       elseif me.data.MCA.model== 7,
           PrintDescriptivesMCA(me.output,me.data.MCA,get(handles.DetailedOutput,'value'),get(handles.ParallelAnalysis,'value'));
           if get(handles.AssessDimesionality,'value') == 1,
              PrintInertiasMCA(me.output,get(handles.DetailedOutput,'value'));
           end;
       elseif me.data.MCA.model== 8,
           PrintDescriptivesMCA(me.output,me.data.MCA,get(handles.DetailedOutput,'value'),get(handles.ParallelAnalysis,'value'));
           if get(handles.AssessDimesionality,'value') == 1,
              PrintInertiasMCA(me.output,get(handles.DetailedOutput,'value'));
           end;
       end;
       
       if me.data.MCA.model== 1,
          PrintCoordinatesMCA(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 2,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 3,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 4,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 5,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 9,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 6,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 7,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       if me.data.MCA.model== 8,
          PrintCoordinatesMCABurt(me.output,me.data.MCA.k,me.data.model.coordinates,get(handles.DetailedOutput,'value'));
       end;
       
       if me.data.rotation.compute == 1,  
           if me.data.MCA.model== 4,
              PrintRotationMCA2(me.rotation,me.data.rotation.method, me.data.rotation.weights, me.output.labels, get(handles.DetailedOutput,'value'),isfield(me.output,'ARC')); 
           elseif me.data.MCA.model== 5,
              PrintRotationMCA2(me.rotation,me.data.rotation.method, me.data.rotation.weights, me.output.labels, get(handles.DetailedOutput,'value'),isfield(me.output,'ARC')); 
           elseif me.data.MCA.model== 9,
              PrintRotationMCA1(me.rotation,me.data.rotation.method, me.data.rotation.weights, me.output.labels, get(handles.DetailedOutput,'value'),isfield(me.output,'ARC')); 
           elseif me.data.MCA.model== 6,
              PrintRotationMCA1(me.rotation,me.data.rotation.method, me.data.rotation.weights, me.output.labels, get(handles.DetailedOutput,'value'),isfield(me.output,'ARC')); 
           elseif me.data.MCA.model== 7,
              PrintRotationMCA1(me.rotation,me.data.rotation.method, me.data.rotation.weights, me.output.labels, get(handles.DetailedOutput,'value'),isfield(me.output,'ARC')); 
           elseif me.data.MCA.model== 8,
              PrintRotationMCA1(me.rotation,me.data.rotation.method, me.data.rotation.weights, me.output.labels, get(handles.DetailedOutput,'value'),isfield(me.output,'ARC')); 
           end;
               
       end;
       
   catch
		disp(lasterr);
   end;

   diary off;
   clc;
   me.str=sprintf('system(''notepad %s &'');',char(me.OutputFile));
   eval(me.str);

%   me.str=sprintf('web(''-toolbar'',[''file:///'' which(''%s'')]);',char(me.OutputFile));
%   eval(me.str);

   set(gcbf,'Pointer','arrow');
   
   if get(handles.ShowMap,'value') == 1,
        if me.data.rotation.compute == 0,  
        %print unrotated MAP
            if me.data.MCA.model== 4,
               %JCA 
               mapMCA4(1,2,0);
            else,
               %MCA 
               f2=get(handles.MapVariables,'value');
               if f2 == 1,
                   %Only variables  
                   mapMCA2(1,2,0);
               else,
                   %Variables and observations  
                   mapMCA1(1,2,0);
               end;
            end;
        else,
              %print orthogonally rotated MAP
              if (me.data.MCA.rotation == 1),  
                    if me.data.MCA.model== 4,
                       %JCA
                       mapMCA4rotated(1,2,0);
                    else
                       %MCA
                       f2=get(handles.MapVariables,'value');
                       if f2 == 1,
                           %Only variables  
                           mapMCA2rotated(1,2,0);
                       else,
                           %Variables and observations  
                           mapMCA1rotated(1,2,0);
                       end;
                    end;
              end;
        end;
   end;
   
   disp('Job done!');
   disp(' ');
   disp(['The output has been saved in file: ''' char(me.OutputFile) '''']);
   disp(' ');
   if exist('tmp.mat','file'), system('del tmp.mat'); end;

return;


% --- Executes on button press in Model4.
%function Model4_Callback(hObject, eventdata, handles)
% hObject    handle to Model4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Model4


% --- Executes on button press in AssessDimesionality.
function AssessDimesionality_Callback(hObject, eventdata, handles)
% hObject    handle to AssessDimesionality (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AssessDimesionality


% --- Executes on button press in ShowVariablesMap.
function ShowVariablesMap_Callback(hObject, eventdata, handles)
% hObject    handle to ShowVariablesMap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShowVariablesMap
    set(handles.ShowVariablesMap,'value',1);
    set(handles.ShowIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);


% --- Executes on button press in ShowIndividualsMap.
function ShowIndividualsMap_Callback(hObject, eventdata, handles)
% hObject    handle to ShowIndividualsMap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShowIndividualsMap
    set(handles.ShowVariablesMap,'value',0);
    set(handles.ShowIndividualsMap,'value',1);
    set(handles.ShowVariablesIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);


% --- Executes on button press in ShowVariablesIndividualsMap.
function ShowVariablesIndividualsMap_Callback(hObject, eventdata, handles)
% hObject    handle to ShowVariablesIndividualsMap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShowVariablesIndividualsMap
    set(handles.ShowVariablesMap,'value',0);
    set(handles.ShowIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap,'value',1);
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',0);

% --- Executes on button press in ShowVariablesIndividualsMap_EqualSpread.
function ShowVariablesIndividualsMap_EqualSpread_Callback(hObject, eventdata, handles)
% hObject    handle to ShowVariablesIndividualsMap_EqualSpread (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShowVariablesIndividualsMap_EqualSpread
    set(handles.ShowVariablesMap,'value',0);
    set(handles.ShowIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap,'value',0);
    set(handles.ShowVariablesIndividualsMap_EqualSpread,'value',1);

% --- Executes on selection change in RotationMethod.
function RotationMethod_Callback(hObject, eventdata, handles)
% hObject    handle to RotationMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 tmp = get(handles.RotationMethod,'value');
   if tmp == 1,
      set(handles.ShowMap,'enable','on');
      set(handles.MapVariables,'enable','on');
      f2=get(handles.Model4,'value');
      %MCA
      if f2 == 1,
         set(handles.MapVariablesObservations,'enable','on');
      end;
   else
      set(handles.ShowMap,'enable','off');
      set(handles.MapVariables,'enable','off');
      set(handles.MapVariablesObservations,'enable','off');
   end;

% --- Executes on button press in ShowMap.
function ShowMap_Callback(hObject, eventdata, handles)
% hObject    handle to ShowMap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ShowMap
   tmp = get(handles.ShowMap,'value');
   if tmp == 1,
    set(handles.ShowMap,'value',1);
    set(handles.MapVariables,'enable','on');
    tmp2 = get(handles.Model4,'value');
    %MCA
    if tmp2==1,
        set(handles.MapVariablesObservations,'enable','on');
    end;
   else
    set(handles.ShowMap,'value',0);
    set(handles.MapVariables,'enable','off');
    set(handles.MapVariablesObservations,'enable','off');
   end;

% --- Executes on button press in MapVariables.
function MapVariables_Callback(hObject, eventdata, handles)
% hObject    handle to MapVariables (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of MapVariables
    set(handles.MapVariables,'value',1);
    set(handles.MapVariablesObservations,'value',0);


% --- Executes on button press in MapVariablesObservations.
function MapVariablesObservations_Callback(hObject, eventdata, handles)
% hObject    handle to MapVariablesObservations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of MapVariablesObservations
    set(handles.MapVariables,'value',0);
    set(handles.MapVariablesObservations,'value',1);
% --- Executes on button press in ComputeRotation.

function ComputeRotation_Callback(hObject, eventdata, handles)
% hObject    handle to ComputeRotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ComputeRotation
    f=get(handles.ComputeRotation,'value');
    if f == 1,
        set(handles.WeightsRotation,'enable','on');
        set(handles.RotationMethod,'enable','on');
         tmp = get(handles.RotationMethod,'value');
         %orthogonal rotation
         if tmp == 1,
            set(handles.ShowMap,'enable','on');
            set(handles.MapVariables,'enable','on');
            f2=get(handles.Model4,'value');
            %MCA
            if f2 == 1,
               set(handles.MapVariablesObservations,'enable','on');
            end;
         %oblique rotation   
         else,
            set(handles.ShowMap,'enable','off');
            set(handles.MapVariables,'enable','off');
            set(handles.MapVariablesObservations,'enable','off');
             
         end;
    else,
        set(handles.WeightsRotation,'enable','off');
        set(handles.RotationMethod,'enable','off');
        set(handles.ShowMap,'enable','on');
        set(handles.MapVariables,'enable','on');
        f2=get(handles.Model4,'value');
        %MCA
        if f2 == 1,
           set(handles.MapVariablesObservations,'enable','on');
        end;
    end;
